/* 
    qasn1 - Asn1BerSerializer - serializer class for qasn1 library
    Copyright(C) 2010 - Andrius da Costa Ribas

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ASN1BERSERIALIZER_H
#define ASN1BERSERIALIZER_H

#include <QtCore/QBuffer>
#include "qasn1_export.h"
#include "Asn1BerNode.h"

class Asn1BerSerializerPrivate;
class QASN1_EXPORT Asn1BerSerializer
{
private:
    Asn1BerSerializerPrivate* d;
public:
    Asn1BerSerializer(Asn1BerNode* node, QIODevice* oStream);
    Asn1BerSerializer(Asn1BerNode* node, QByteArray* oStream);
    
    virtual ~Asn1BerSerializer();
    
    void serializeCurrentOnly(); // includes subnodes
    void serializeFromCurrent();
    void serializeAllTree();
};

#endif
